#mygamebox
#See http://www.mrexcessive.net/games
#
#mygamebox game manager application for pygame games
#This is free software in the http://www.fsf.org/ sense
#It uses pygame, http://www.pygame.org/

try:
   import os,sys,getopt,copy
   import re
   import random
   import math
   import pygame
   from pygame.locals import *
   sys.path.append('../')
   from gamebox.miniconsole import MiniConsole
except ImportError, err:
   print "couldn't load module. %s" % (err)
   sys.exit(2)

#YYY = explain. ZZZ = todo. XXX = bad thing to remove/replace

#ZZZ initial display of found games, based on configuration text file
#ZZZ console commands to load games
#ZZZ suitable font for smaller chars and many wierd things like /\#'@
#ZZZ gamebox.utility to register in mygamebox, directory structure.

silent = 0  # allow sounds
doconsole = 1 # use console mode
doconsolefromstart = 1 # not from start
playthisgame = ""
OPTIONS = {}

#game global options, controlled by command line
def usage():
   print "Usage:"
   print "python mygamebox.py [-F]"
   print "   -f   =   Fullscreen mode"
   print "   -h   =   Print usage information"
   print

def load_image(name, colorkey=None):
   fullname = os.path.join('data',name)
   try:
      image = pygame.image.load(fullname)
   except pygame.error, message:
      print 'Cannot load image:', name
      raise SystemExit, message
   image = image.convert()
   if colorkey is not None:
      if colorkey is -1:
         colorkey = image.get_at((0,0))
      image.set_colorkey(colorkey, RLEACCEL)
   return image, image.get_rect()
   
def load_sound(name):
   if not pygame.mixer:
      return NoSound()
   fullname = os.path.join('data',name)
   try:
      sound = pygame.mixer.Sound(fullname)
   except pygame.error, message:
      print 'Cannot load sound:', name
      raise SystemExit, message
   return sound

def load_music(name):
   if not pygame.mixer.music:
      return NoneSound()
   fullname = os.path.join('data',name)
   try:
      music = pygame.mixer.Sound(fullname)
   except pygame.error, message:
      print 'Cannot load music:', name
      raise SystemExit, message
   return music


def set_background():
   fname = 'background_mygamebox.jpg'
   bgimage,bgrect = load_image(fname,-1)
   bgimage = bgimage.convert()
   background = pygame.Surface(screen.get_size())
   background.blit(bgimage,(0,0))
   #Put level text on screen
   #YYYChange to use messages, maybe somehow. oneday
   font = pygame.font.Font("kitchen.ttf",36)
   text = font.render("MyGameBox", 1, (255,128,128))
   textpos = text.get_rect()
   textpos.centerx = background.get_rect().centerx
   background.blit(text,textpos)
   return background

class Message(pygame.sprite.Sprite):
   """a message to user"""
   font = {}
 
   def __init__(self,msg,colour=None,fontsize=36,finaloffset = (0,0),flyoffin = 0):
      pygame.sprite.Sprite.__init__(self)
      a=1
      if not Message.font.has_key(fontsize):
         Message.font[fontsize] = pygame.font.Font("kitchen.ttf",fontsize)      # oh so big ZZZ get new free/nice ttf      
      if not colour:
         colour = ( random.randint(100,255), random.randint(100,255), random.randint(100,255) )
      text = Message.font[fontsize].render( msg, 1, colour )
      self.image = text
      self.area = screen.get_rect()       # where it is allowed to be
      self.rect = self.image.get_rect()
      self.rect.midtop = self.area.midtop
      self.finaloffset = finaloffset
      self.move = (0,+5)
      self.moving = 2
      self.tigger = 1
      self.auto_flyoffin = flyoffin  # don't normally
      
   def flyoff(self):
      self.move = (+7,-6)
      self.moving = 1
   
   def update(self):
      """ZZZmove and draw"""
      if self.moving:               # flying in(2) or out(1)
         newpos = self.rect.move(self.move)
         if self.moving == 1:       # out(1)
            if not self.area.colliderect(newpos):
               self.kill()
            else:
               self.rect = newpos
         elif self.moving == 2:     # heavy gravity bounce score until slow
            gravity = .05
            self.newmove = (self.move[0],self.move[1]+gravity*8)
            self.testarea = self.area.move(self.finaloffset)   # the bounce against floor at resting place offset
            if not self.testarea.contains(newpos):
               self.tigger -= 1
               if not self.tigger:  # stop bouncing
                  self.moving = 0
               else:          # lose some energy on the bounce
                  self.move = (self.move[0],-self.move[1]*0.8)
                  newpos = self.rect.move(self.move)
                  self.rect = newpos
            else:
               self.move = self.newmove
               self.rect = newpos
      elif self.auto_flyoffin:
         self.auto_flyoffin -= 1
         if not self.auto_flyoffin:
            self.flyoff()


class Nosound:
   def __init__(self):
      pass
   def play(self):
      pass
   def set_volume(self,val):
      pass


# ZZZ this is NOT a way to play games, cmon, this is in an event handler...
# ZZZ no... we need to queue a request to the top level and then switch to game event loop
def user_command(cmd):
   "do what the user wants. e.g. load games, get games, run games, chat"
   m = re.match(r"load (\S+)", cmd)
   if m:
      global playthisgame
      playthisgame = m.group(1)   # get game name
      print "About to play " + playthisgame
   else:
      return "Unknown command"
      
def play_game():
   global playthisgame
   gn = playthisgame
   playthisgame = ""
   print "Trying to play [" + str(gn) + "]"
   try:
      pygame.quit()     # drop screens and backgrounds and so on
      os.chdir('../' + gn)
      #print "CWD = [" + str(os.getcwd()) + "]"
      #RUN = gn + '.py -x'; os.startfile(RUN)    # This DOES work on Windows
      RUN = ['python',gn + '.py','-x'];
      try:
         os.execvp('python',RUN)       # this doesn't return
      except:
         print "oh dear ", sys.exc_info()[0]
         print "suppl ", sys.exc_info()[1]
   except:
      # XXX ZZZ will need to get screens back
      print "ugh"
      return ["Cannot spawn new game",gn]


def mainscreen(initial_outputs):
   global silent
   background = set_background()
   screen.blit(background,(0,0))
   if doconsole:
      console_surface = pygame.Surface(screen.get_rect().size)
      console = MiniConsole(console_surface,visible=doconsolefromstart,fontsize=40)
      console_surface.set_alpha(255)   # gamebox uses full console
      console.customize(visiblekey = K_F1)
      if initial_outputs:
         for io in initial_outputs:
            print >> console, io 
   pygame.display.flip()
   messages = []
   example = Message("F1 for console, ESC to quit",fontsize=30,colour=(255,255,64),finaloffset=(0,-20),flyoffin = 300)
   messages = messages + [example]
   messagesprites = pygame.sprite.RenderUpdates(messages)
   clock = pygame.time.Clock()
   keysdown = {}
   pause = 0
   global playthisgame
   # Reset things, after all main() plays the game, once highscore and splash page added then main will get called multiple times
   while playthisgame == "":
      changed_rects = []
      clock.tick(24)       # limit fps
      for event in pygame.event.get():
         event = console.handle(event)
         if event.type == USEREVENT:
            #print 'YOU TYPED: "%s"' % event.command
            response = user_command(event.command)
            if response:
               print >> console, response
         else:
            if event.type is QUIT:
               return 0 # stop playing
            elif event.type is KEYDOWN:
               if event.key is K_ESCAPE:
                  return 0 # stop playing
               elif event.key == K_s:
                  silent = not silent
               elif event.key == K_p:
                  pause = not pause
               else:
                  keysdown[event.key] = 1
            elif event.type is KEYUP:
               if keysdown.has_key(event.key):
                  del keysdown[event.key]

      if not pause:
         #YYY how to check a key
         #if keysdown.has_key(K_QUOTE): batB.fireball()

         if doconsole:
            if console.consolechange:
               console.consolechange = 0  # reset bus ready
               if not console.visible:    # if just switched off... redraw background
                  screen.blit(background,(0,0))
                  changed_rects += [screen.get_rect()]

         #undraw the sprites
         messagesprites.clear(screen,background)
         
         #move the sprites
         messagesprites.update()
      
         #draw the sprites
         changed_rects += messagesprites.draw(screen)

         #draw the console (over sprites)
         if doconsole:
            if console.visible:
               changed_rects += [console.draw()]
               screen.blit(console_surface,(0,0))

         pygame.display.update(changed_rects)
         
   # while global(playthisgame) == "": ends
   return 1
   

def main():
   global playthisgame
   playing = -1
   initial_outputs = []
   initial_outputs.append("Commands.")
   initial_outputs.append(" H)elp")
   initial_outputs.append(" G)et new game")
   initial_outputs.append(" P)lay game")
   initial_outputs.append(" S)end game to a friend")
   while playing:
      playing = mainscreen(initial_outputs)
      if playthisgame != "":
         initial_outputs = play_game()       # this never returns, relies on execd game chaining back to us
         playing = 0
   return
   

#GAME STARTS HERE            
   
pygame.init()
OPTIONS['fullscreen'] = 0
OPTIONS['getscores'] = 0
try:
   opts, args = getopt.getopt(sys.argv[1:], "hfs", ["help", "output=","scores"])
except getopt.GetoptError:
   usage()
   sys.exit(2)
for o, a in opts:
   if o in ("-h", "--help"):
      usage()
      sys.exit()
   if o == '-f':
      OPTIONS['fullscreen'] = 1
   if o == '-s':
      OPTIONS['getscores'] = 1
if OPTIONS['fullscreen']:
   screen = pygame.display.set_mode((640,480),FULLSCREEN)
else:
   screen = pygame.display.set_mode((640,480))
# We need better than 8 bit color depth
if screen.get_bytesize() < 2:
   print "This program requires more than 256 colours."
   print "Please change your display to 16bit or 32bit colour."
   raise SystemExit
pygame.display.set_caption('excessive MY GAMEBOX')
pygame.mouse.set_visible(0)


if __name__ == '__main__':
   main()

# end of file mygamebox.py
