#WHERE ARE BAT LIVES HELD

#PyPong
#See http://www.mrexcessive.net/games
#
#Ancient game of tennis. Two player
#This is free software in the http://www.fsf.org/ sense
#It uses pygame, http://www.pygame.org/


try:
   import os,sys,getopt,copy
   import random
   import math
   import pygame
   from pygame.locals import *
   sys.path.append('../')
   from gamebox.miniconsole import MiniConsole
except ImportError, err:
   print "couldn't load module. %s" % (err)
   sys.exit(2)

#YYY = explain. ZZZ = todo. XXX = bad thing to remove/replace

#ZZZ levels
#ZZZ do ball hits based on coord compares not sprite colln... or something to avoid bad bounces !
#ZZZ more brick types - bats get 'sticktobat' uses from eliminating other players bricks completely. #ZZZ fly these priviliges
#ZZZ display score
#ZZZ Fixed number of balls per level. Show them in a hopper, animate out of hopper ?
#ZZZ different ball types
#ZZZ powerups to collect with bats (as well as ball bouncing), they come down from middle at random time and go to both players.
#ZZZ smallbat / bigbat powerups

silent = 0  # allow sounds
doconsole = 1 # use console mode
doconsolefromstart = 0 # not from start
keysdown = {}
OPTIONS = {}

#game global options, controlled by command line
def usage():
   print "Usage:"
   print "python pypong.py [-F]"
   print "   -f   =   Fullscreen mode"
   print "   -h   =   Print usage information"
   print "   -x   =   Run mygamebox at end and update scores"
   print 


def load_image(name, colorkey=None):
   fullname = os.path.join('data',name)
   try:
      image = pygame.image.load(fullname)
   except pygame.error, message:
      print 'Cannot load image:', name
      raise SystemExit, message
   image = image.convert()
   if colorkey is not None:
      if colorkey is -1:
         colorkey = image.get_at((0,0))
      image.set_colorkey(colorkey, RLEACCEL)
   return image, image.get_rect()
   
def load_sound(name):
   if not pygame.mixer:
      return NoSound()
   fullname = os.path.join('data',name)
   try:
      sound = pygame.mixer.Sound(fullname)
   except pygame.error, message:
      print 'Cannot load sound:', name
      raise SystemExit, message
   return sound

def load_music(name):
   if not pygame.mixer.music:
      return NoneSound()
   fullname = os.path.join('data',name)
   try:
      music = pygame.mixer.Sound(fullname)
   except pygame.error, message:
      print 'Cannot load music:', name
      raise SystemExit, message
   return music


def set_background(level):
   fnames = ['darkknit_level1.jpg']
   fname = fnames[(level-1) % len(fnames)]
   bgimage,bgrect = load_image(fname,-1)
   bgimage = bgimage.convert()
   bgimage.set_alpha(192)        # slightly faded
   background = pygame.Surface(screen.get_size())
   background.blit(bgimage,(0,0))
   #Put level text on screen
   #YYYChange to use messages, maybe somehow. oneday
   font = pygame.font.Font("kitchen.ttf",36)
   text = font.render("LEVEL " + str(level), 1, (0,0,0))
   textpos = text.get_rect()
   textpos.centerx = background.get_rect().centerx
   background.blit(text,textpos)
   return background

class Message(pygame.sprite.Sprite):
   """a message to user"""
   font = {}
 
   def __init__(self,msg,colour=None,fontsize=36,finaloffset = (0,0),finalpos = (-1,-1), flyoffin = 0,moving = 2):
      pygame.sprite.Sprite.__init__(self)
      self.set(msg,colour,fontsize,finaloffset,finalpos,flyoffin,moving)
      self.area = screen.get_rect()       # where it is allowed to be
      if self.moving in range(3,5):
         self.update()     # move to final position immediately
      else:
         self.rect.midtop = self.area.midtop
         self.tigger = 1
         self.move = (0,+5)
      
   def flyoff(self):
      self.move = (+7,-6)
      self.moving = 1
   
   def set(self,text,colour=(255,255,255),fontsize=36,finaloffset=(0,0),finalpos=(-1,-1),flyoffin=0,moving=2):
      self.rect = pygame.Rect((0,0,0,0))
      self.set_text(text = text,colour = colour,fontsize = fontsize,\
         finaloffset = finaloffset,finalpos = finalpos,flyoffin = flyoffin,moving = moving)
      
   def set_text(self,text=None,colour=None,fontsize=None,finaloffset=None,finalpos=None,flyoffin=None,moving=None):
      rerender = 0
      if fontsize != None: self.fontsize = fontsize; rerender = 1
      if colour != None: self.colour = colour; rerender = 1
      if text != None: self.text = text; rerender = 1
      if finaloffset != None: self.finaloffset = finaloffset
      if finalpos != None: self.finalpos = finalpos
      if flyoffin != None: self.auto_flyoffin = flyoffin
      if moving != None: self.moving = moving
      if rerender:
         if not Message.font.has_key(self.fontsize):
            Message.font[self.fontsize] = pygame.font.Font("kitchen.ttf",self.fontsize)      # oh so big ZZZ get new free/nice ttf      
         self.font = Message.font[self.fontsize]
         textimage = self.font.render(self.text,1,self.colour)
         self.image = textimage
         oldrectcenter = self.rect.center
         self.rect = self.image.get_rect()
         self.rect.center = oldrectcenter    # keep same center NB could keep same topleft... whatever         
   
   def update(self):
      """ZZZmove and draw"""
      if self.moving:   # not finished current move yet
         if self.moving == 1:       # out(1)
            newpos = self.rect.move(self.move)
            if not self.area.colliderect(newpos):
               self.kill()
            else:
               self.rect = newpos
         elif self.moving == 2:     # heavy gravity bounce score until slow
            newpos = self.rect.move(self.move)
            gravity = .05
            self.newmove = (self.move[0],self.move[1]+gravity*8)
            self.testarea = self.area.move(self.finaloffset)   # the bounce against floor at resting place offset
            if not self.testarea.contains(newpos):
               self.tigger -= 1
               if not self.tigger:  # stop bouncing
                  self.moving = 0
               else:          # lose some energy on the bounce
                  self.move = (self.move[0],-self.move[1]*0.8)
                  newpos = self.rect.move(self.move)
                  self.rect = newpos
            else:
               self.move = self.newmove
               self.rect = newpos
         elif self.moving == 3:     # just put straight away at finalpos
            self.rect.topleft = self.finalpos
            self.moving = 0
         elif self.moving == 4:     # just put straight away centered at finalpos
            self.rect.center = self.finalpos
            self.moving = 0
      elif self.auto_flyoffin != 0:
         self.auto_flyoffin -= 1
         if self.auto_flyoffin <= 0:
            self.flyoff()

class Nosound:
   def __init__(self):
      pass
   def play(self):
      pass
   def set_volume(self,val):
      pass
  
class Bat(pygame.sprite.Sprite):
   """moves bat turret, following key commands"""
   def __init__(self,which,size):
      pygame.sprite.Sprite.__init__(self)    #call Sprite initialiser
      self.image, self.rect = preload_bat_images[which][size]
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.which = which      # 0 == left, 1 == right (and in a fit of madness... 2 == top, 3 == bottom)
      self.size = size           # 0 == tiny, 1 == mid, 2 == large, 3 == hugesonopoints
      self.reinit()

   def reinit(self):
      if self.which == 0:
         self.rect.midleft = self.area.midleft
         self.rect = self.rect.move(40,0)         # right a bit
      elif self.which == 1:
         self.rect.midright = self.area.midright
         self.rect = self.rect.move(-40,0)         # left a bit (space for bricks &c.)
      self.movepos = [0,0]     # offset since last .update()
      self.basespeed = 11
      self.diein = 0
      self.scoredpoints = 0      # extra points scored recently
      self.inmotion = 0
      self.ballstuck = None      # ball stuck on here

   def fireball(self):
      "fire the ball which is stuck to this bat, slightly random angle"
      if self.ballstuck:
         self.ballstuck.unstick()
         self.ballstuck = None

   def stuck_topleft(self,ballwidth,ballheight):
      "returns topleft of ball stuck in middle of bat"
      (tx,ty) = self.rect.topleft
      if self.which == 0:
         tx += (self.rect.width - 4)
      elif self.which == 1:
         tx -= (ballwidth - 4)
      else:
         #ZZZ bats 2,3
         pass
      ty += (self.rect.height - ballheight) / 2
      return (tx,ty)
      
   def stick_a_ball(self,ball):
      "sticks the ball on"
      #ZZZ do stuff
      self.ballstuck = ball
      
   def scoreup(self,howmuch):
      self.scoredpoints += howmuch * (3 - self.size)     # so size 0(tiny) gets 3* and size 2 normal, size 3 gets nothing(ie too easy)

   def getscore(self):
      scored =  +self.scoredpoints
      self.scoredpoints = 0
      return scored

   def moveleft(self,faster = 1):
      self.movepos[0] = self.movepos[0] - (self.basespeed * faster)
      
   def moveright(self,faster = 1):
      self.movepos[0] = self.movepos[0] + (self.basespeed * faster)
   
   def moveup(self,faster = 1):
      self.movepos[1] = self.movepos[1] - (self.basespeed * faster)
      
   def movedown(self,faster = 1):
      self.movepos[1] = self.movepos[1] + (self.basespeed * faster)
      
   def set_dying(self):
      self.basespeed = 3      # will it get away
      self.diein = 50         # 2 seconds or so (24 fps). er no.
   
   def update(self):
      "move bat as required by .movepos deltas"
      if not self.diein:
         if self.movepos != [0,0]:
            self.inmotion = 1
         else:
            self.inmotion = 0
         newpos = self.rect.move(self.movepos)
         self.movepos = [0,0]
         if self.area.contains(newpos):
            self.rect = newpos
      else:    # die if necessary
         self.diein -= 1
         if self.diein == 0:
            self.kill()
            lostsprites.add([self])
            #ZZZ for now, wipe out score
         else:
            self.dying_alpha -= self.fadealpha
            self.image.set_alpha(self.dying_alpha)
            
   def canshoot(self):
      "return -1 if can shoot, otherwise 0"
      return not self.diein
   
   def hit(self):
      if not silent: bouncebat_sound.play()     # just play once


class Brick(pygame.sprite.Sprite):
   """a brick, which can get hit and repel ball"""
   brick_fnames = ['brick.png','brick_red.png','brick_yellow.png']
   def __init__(self,xy,which,lives = 1,flyinsteps = 20):
      pygame.sprite.Sprite.__init__(self)    #call Sprite initialiser
      self.lives = lives - 1     # number of extra lives remaining is stored
      fname = Brick.brick_fnames[self.lives]
      self.image, self.rect = load_image(fname,-1)
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.which = which # which bat/team
      self.reinit()
      self.targetpos = xy     # where to get to
      self.moving = 1
      self.rect.topleft = self.area.center
      self.flyinsteps = flyinsteps
      self.image.set_alpha(150)

   def reinit(self):
      self.diein = 0
      
   def set_dying(self):
      self.diein = 15         # 1/2 seconds or so (24 fps)
   
   def update(self):
      "die if required"
      if self.diein:
         self.diein -= 1
         if not self.diein:
            self.kill() # ZZZ doesn't become a lostsprite (for now...)
         else:
            self.dying_alpha -= self.fadealpha     # fade out
            self.image.set_alpha(self.dying_alpha)
      if self.moving:
         (tx,ty) = self.targetpos
         (x,y) = self.rect.topleft
         (ox,oy) = (tx - x, ty - y)
         if abs(oy) > 10:
            dy = max(abs(oy/self.flyinsteps),5)
            if oy < 0: dy = -dy     # ZZZ what is sign(oy) in Python ?
            xy = (x,y + dy)
         else:
            y = ty
            if abs(ox) > 10:
               dx = max(abs(ox/self.flyinsteps),5)
               if ox < 0: dx = -dx  # ZZZ *= sign(oy)
               xy = (x+dx,y)
            else:
               xy =(tx,ty)
               self.moving = 0
               self.image.set_alpha(255)
         self.rect.topleft = xy
   
   def hit(self):
      old_rect_center = self.rect.center
      if self.lives > 0:
         self.lives -= 1
         fname = Brick.brick_fnames[self.lives]
         self.image, self.rect = load_image(fname,-1)
         self.rect.center = old_rect_center
         if not silent: brickhit_sound.play()
      else:
         self.image,self.rect = load_image('brick.png',-1)  # ZZZ change to dead brick image, perhaps
         if not silent: brickhitdead_sound.play()
         self.rect.center = old_rect_center
         self.set_dying()
         self.dying_alpha = 255
         self.fadealpha = int(self.dying_alpha / self.diein)
      
         
class Ball(pygame.sprite.Sprite):
   """a ball bounces around the screen"""
   def __init__( self, (xy), vector, bats, bricks):
      pygame.sprite.Sprite.__init__(self)    # call Sprite initialiser
      self.image, self.rect = load_image('ball1.png',-1)
      self.original_image = self.image
      screen = pygame.display.get_surface()
      self.area = screen.get_rect()
      self.rect.topleft = xy
      self.vector = vector
      self.rotateangle = 0
      self.rotateangle_change = 10
      self.batsprites = bats
      self.bricksprites = bricks
      self.score_hitbat = 10     # basic number of points for ball hitting bat
      self.score_hitbrick = 53   # basic number of points for hitting brick
      self.unpredictableangle = math.pi / 40
      self.hitbat_which = -1 # not hit a bat
      self.hitbrick_which = None
      self.stucktobat = None     # not stuck on a bat
      
   def unstick(self):
      # unstick from bat
      bat = self.stucktobat
      self.stucktobat = None
      if bat:
         if bat.inmotion:
            rand = (0.06 * (random.randint(0,20)-10)) # wild
         else:
            rand = (0.02 * (random.randint(0,20)-10)) # not so wild
         if bat.which == 0:
            angle = (rand) * math.pi
         elif bat.which == 1:
            angle = math.pi + (rand) * math.pi
         else:
            #ZZZ bats 2,3
            pass
         self.vector = (angle,11)      # faster off a bat (maybe slow down after a bit)
         self.rect = self.calcnewpos(self.rect,self.vector) # move twice extra to get away from bat (ugh... but ugh the other way too)
         self.rect = self.calcnewpos(self.rect,self.vector)
      
   def calcnewpos(self,rect,vector):
      # where would rect be with this vector
      if not self.stucktobat:
         (angle,z) = vector
         (dx,dy) = (z*math.cos(angle),z*math.sin(angle))
         return rect.move(dx,dy)
      else:
         self.rect.topleft = self.stucktobat.stuck_topleft(self.rect.width,self.rect.height)    # balls stick in the middle (this gets its posn)
         return self.rect
         
   def update(self):
      "move the ball"
      newpos = self.calcnewpos(self.rect,self.vector)
      if not self.stucktobat:
         #rotate our image as we go (slowly), ZZZ again use precalculated rotation shots
         rotate = pygame.transform.rotate
         self.rotateangle += self.rotateangle_change
         rotated_image = rotate(self.original_image,self.rotateangle)
         rotated_rect = rotated_image.get_rect()
         rotated_rect.center = newpos.center
         newpos = rotated_rect
         self.image = rotated_image
      # BOUNCE ON WALLS
      if not self.area.contains(newpos):
         tl = not self.area.collidepoint(newpos.topleft)
         tr = not self.area.collidepoint(newpos.topright)
         bl = not self.area.collidepoint(newpos.bottomleft)
         br = not self.area.collidepoint(newpos.bottomright)
         (angle,z) = self.vector
         self.hitbat_which = -1
         if tl and tr or (bl and br):     # bounce top or bottom
            angle = -angle
         if tr and br or (tl and bl):     # off left or right (don't bounce, just restart/// ZZZ lose a life, whatever
            #offscreen
            playmore = 1
            if tl and bl:
               playmore = self.goneoffscreen(0)      # playerA
            else:
               playmore = self.goneoffscreen(1)      # player B
            newpos = self.rect      #YYY reset position and continue, possibly change movement pattern to 'flying in'
            self.rect.center = self.area.center
            self.hitbat_which = -1
            self.hitbrick_which = -1
         self.vector = (angle,z)
         newpos = self.calcnewpos(newpos,self.vector)
         if not silent: bouncewall_sound.play()
         self.rotateangle_change = -self.rotateangle_change      # spin t'other way
      elif 1: # BOUNCE ON BATS
         hitbats = insensitive_spritecollide(5,self,self.batsprites,0)  # Hit any bats ? (don't kill them)
         (drop,my_min_ypos) = self.rect.topleft
         my_max_ypos = my_min_ypos + self.rect.height
         (angle,z) = self.vector
         flag_hitabat = 0
         if hitbats: # need bat to score
            for bat in hitbats:     #ZZZ XXX NOTE THIS CODE ONLY WORKS FOR VERTICALLY MOVING BATS
               flag_stuck = 0
               if bat.which == 0 and keysdown.has_key(K_a):
                  flag_stuck = 1
                  del keysdown[K_a]
               elif bat.which == 1 and keysdown.has_key(K_k):
                  flag_stuck = 1
                  del keysdown[K_k]
               if flag_stuck:
                  self.stucktobat = bat
                  bat.stick_a_ball(self)
               if self.hitbat_which != bat.which:
                  flag_hitabat = 1
                  self.hitbat_which = bat.which
                  self.hitbrick_which = -1
                  bat.hit()
                  bat.scoreup(self.score_hitbat)
                  (drop,bat_min_ypos) = bat.rect.topleft
                  bat_max_ypos = bat_min_ypos + bat.rect.height
                  if my_min_ypos >= bat_min_ypos and my_max_ypos <= bat_max_ypos:
                     # if hit bat face square on, not corner
                     angle = math.pi - angle
                     #angle = self.avoid(angle)
                  else:
                     # hit either top or bottom edge
                     angle = math.pi - angle    # ZZZ do it different...
                     #YYY hey how about random
                     ua = self.unpredictableangle
                     ua_random = (random.random() * 2 * ua) - ua
                     angle += ua_random
                     angle =self.avoid(angle)
                  if bat.inmotion:
                     angle = self.seek(angle)
                  #ZZZXXX put something in to ensure ball direction is +ve sense away from bat back in to play area...
                  #So crazy trapped bounces get stopped
                  angle = self.purebounce(angle,self.hitbat_which)
            if flag_hitabat:
               self.rotateangle_change = -self.rotateangle_change
            #else:
            #   self.hitbat_which = -1     # when no hit cancel last hit... this prevents bounce traps on bat
            #            # if sprite moving fast it can otherwise end up straddling the bat and stuck
            angle = self.avoid(angle) #avoid vertical
            self.vector = (angle,z)
            newpos = self.calcnewpos(newpos,self.vector)
      #BOUNCE and DESTROY bricks
      hitbricks = insensitive_spritecollide(10,self,self.bricksprites,0)  # Hit any bats ? (don't kill them)
      (drop,my_min_ypos) = self.rect.topleft
      my_max_ypos = my_min_ypos + self.rect.height
      (angle,z) = self.vector
      flag_hitabrick = 0
      if hitbricks:
         #for brick in hitbricks:
         brick = hitbricks[0] # ZZZ only hit one brick
         if brick.which != self.hitbrick_which:
            self.hitbrick_which = brick.which
            if not brick.diein:     # mustn't be on way out
               flag_hitabrick = 1
               brick.hit()
               # YYY add score to the bat which isn't at the end I just hit a brick at !
               self.batsprites.sprites()[1 - self.hitbrick_which].scoreup(self.score_hitbrick)
               self.hitbat_which = -1  # if hit brick then forget bat
               # ZZZ do special effects &c (or in the dying bit of brick.update)
               (drop,brick_min_ypos) = brick.rect.topleft
               brick_max_ypos = brick_min_ypos + brick.rect.height
               if 1:#my_min_ypos >= brick_min_ypos and my_max_ypos <= brick_max_ypos:
                  # if hit brick face square on, not corner
                  angle = math.pi - angle
                  angle = self.avoid(angle,turn = math.pi/32) # always_avoid moves towards horizontal motion even if nearly there.
               else:
                  # hit either top or bottom edge
                  angle = math.pi - angle    # ZZZ this is wrong
                  #YYY hey how about random
                  ua = self.unpredictableangle
                  ua_random = (random.random() * 2 * ua) - ua
                  angle += ua_random
            if flag_hitabrick:
               self.rotateangle_change = -self.rotateangle_change
            angle = self.avoid(angle) #avoid vertical
            self.vector = (angle,z)
            newpos = self.calcnewpos(newpos,self.vector)

      self.rect = newpos
      
   def purebounce(self,angle,which):
      "ensure bounce direction is towards centre of playarea (from bat)"
      #ZZZ perhaps also from bricks
      angle = self.norm(angle)
      pb2 = math.pi / 2
      pb2t3 = 3 * pb2
      if which == 0:
         if angle > pb2 and angle < pb2t3: #wrong for after collision with bat 0
            angle = math.pi - angle
      elif which == 1:
         if angle < pb2 or angle > pb2t3:
            angle = math.pi - angle
      return angle
      
   def avoid(self,angle,always_avoid = 0,turn = 0):     #ZZZ stay away from angles near to pi/2 and 3*pi/2 (which are vertical movements, impossible for players)
      # YYY always normalise first
      angle = self.norm(angle)
      pb2 = math.pi / 2
      pb2t3 = 3 * pb2
      tooclose = math.pi / 6
      if not turn:
         turn = math.pi / 40
      if angle < pb2:
         if always_avoid or (pb2 - angle) < tooclose:
            angle -= turn
      elif angle < math.pi:
         if always_avoid or (angle - pb2) < tooclose:
            angle += turn
      elif angle < pb2t3:
         if always_avoid or (pb2t3 - angle) < tooclose:
            angle -= turn
      else:
         if always_avoid or (angle - pb2t3) < tooclose:
            angle += turn
      return angle
      
   def seek(self,angle):     #try to get closer to vertical (counteracted by avoid() if too close)
      # YYY always normalise first
      # used when Bat is moving, then player has sliced ball
      angle = self.norm(angle)
      pb2 = math.pi / 2
      pb2t3 = 3 * pb2
      tooclose = math.pi / 6
      turn = math.pi / 25
      if angle < pb2:
         if (pb2 - angle) > tooclose:
            angle += turn
      elif angle < math.pi:
         if (angle - pb2) > tooclose:
            angle -= turn
      elif angle < pb2t3:
         if (pb2t3 - angle) > tooclose:
            angle += turn
      else:
         if (angle - pb2t3) > tooclose:
            angle -= turn
      return angle
   
   def norm(self,angle):      # ZZZ not really a ball func. just math.
      p2 = math.pi * 2
      while angle < 0:
         angle += p2
      while angle >= p2:
         angle -= p2
      return angle
      
   def goneoffscreen(self,which):      # ball has gone behind batA (which =0) or batB (which=1)
      """ deals with score/level/player implications.
      Ball should be restarted in update if this function returns 1.
      if we return 0 then no new ball should be given"""
      return 0    # no new ball
   
      
#Rect shrinking versions of the popular pygame Sprite module utility functions
def insensitive_spritecollide(insensitivity, sprite, group, dokill):
    """pygame.sprite.spritecollide(sprite, group, dokill) -> list
       collision detection between sprite and group
       given a sprite and a group of sprites, this will
       return a list of all the sprites that intersect.
       all sprites must have a "rect" method, which is a
       rectangle of the sprite area. if the dokill argument
       is true, the sprites that do collide will be
       automatically removed from all groups."""
    spritecollide = sprite.rect.colliderect
    crashed = []
    for s in group.sprites():
        testrect = s.rect.inflate(-insensitivity,-insensitivity)     # ZZZ is this right ?
        if spritecollide(testrect):
            if dokill: s.kill()
            crashed.append(s)
    return crashed
    
def insensitive_groupcollide(insensitivity, groupa, groupb, dokilla, dokillb):
    """pygame.sprite.groupcollide(sprite, group, dokill) -> dict
       collision detection between group and group
       given two groups, this will find the intersections
       between all sprites in each group. it returns a
       dictionary of all sprites in the first group that
       collide. the value for each item in the dictionary
       is a list of the sprites in the second group it
       collides with. the two dokill arguments control if
       the sprites from either group will be automatically
       removed from all groups."""
    crashed = {}
    for s in groupa.sprites():
        c = insensitive_spritecollide(insensitivity, s, groupb, dokillb)
        if c:
            crashed[s] = c
            if dokilla: s.kill()
    return crashed
    
def load_resources():
   #Sounds
   global bouncewall_sound, bouncebat_sound, brickhit_sound, brickhitdead_sound
   bouncewall_sound = load_sound('waterdrop.wav'); bouncewall_sound.set_volume(0.2)
   bouncebat_sound = load_sound('bounce1.wav'); bouncebat_sound.set_volume(1.0)
   brickhit_sound = load_sound('bounce2.wav');brickhit_sound.set_volume(0.4)
   brickhitdead_sound = load_sound('beam11.wav');brickhitdead_sound.set_volume(0.4)
   #Pictures
   global preload_bat_images
   preload_bat_images = [load_image('bat1a_small.png',-1),load_image('bat1a.png',-1),load_image('bat1a_big.png',-1)]
   preload_bat_images = [ preload_bat_images, [load_image('bat1b_small.png',-1),load_image('bat1b.png',-1),load_image('bat1b_big.png',-1)] ]

    
def level(level,level_instructions,score,lives):
   global silent,keysdown
   load_resources()
   # [ BRICKS ] [ BATS ]
   (li_bricks,li_bats) = level_instructions
   background = set_background(level)
   screen.blit(background,(0,0))
   if doconsole:
      console_surface = pygame.Surface(screen.get_rect().size)
      console = MiniConsole(console_surface,visible=doconsolefromstart,fontsize=40)
      console_surface.set_alpha(128)
      console.customize(visiblekey = K_F1)
      print >> console, "You're thinking of an animal."
      print >> console, "..."
      print >> console, "Is it a, ... bat ?"
   pygame.display.flip()
   batA = Bat(0,li_bats[0])
   batB = Bat(1,li_bats[1])
   batsprites = pygame.sprite.RenderUpdates([batA,batB])
   #ZZZ Create brick patterns
   #ZZZ Fly in brick patterns... materialise them, whatever
   bricks = []
   for i in range(9):
      brickstrength = li_bricks[i]
      if brickstrength: # if there is a brick
         brick = Brick((8,8+(i*52)),0,brickstrength)      # P0 bricks
         bricks.append(brick)
         brick = Brick((600,8+(i*52)),1,brickstrength)      # P1 bricks
         bricks.append(brick)
   bricksprites = pygame.sprite.RenderUpdates(bricks)
   rand = (1.4 + (0.01 * (random.randint(0,20)-10)))
   ball = Ball((320,50),(rand*math.pi,10),batsprites,bricksprites)
   ballsprites = pygame.sprite.RenderUpdates([ball])
   messages = []
   if level == 1:
      use_players = Message("player1 qaz   player2 okm",fontsize=18,colour=(255,255,64),finaloffset=(0,-80),flyoffin = 105)
      use_con = Message("press F1 for console",fontsize=18,colour=(255,255,64),finaloffset=(0,-60), flyoffin = 110)
      use_pkey = Message("'p' to pause",fontsize=18,colour=(255,255,64),finaloffset=(0,-40), flyoffin = 115)
      use_skey = Message("'s' to toggle sound",fontsize=18,colour=(255,255,64),finaloffset=(0,-20),flyoffin = 120)
      messages += [use_pkey,use_skey,use_con,use_players]
   else:
      pass # no messages
   #create player lives and score messages
   batA_status = Message("A", fontsize=18, colour=(255,255,128), finalpos=(144,42), moving = 4)
   batB_status = Message("B", fontsize=18, colour=(255,255,128), finalpos=(496,42), moving = 4)
   messages += [batA_status,batB_status]
   messagesprites = pygame.sprite.RenderUpdates(messages)
   clock = pygame.time.Clock()
   keysdown = {}
   pause = 0
   framelimit = 40       # limit fps
   framecounter = framelimit     # decrement for controlling things which happen every second (e.g.)
   # Reset things, after all main() plays the game, once highscore and splash page added then main will get called multiple times
   while 1:
      framecounter -= 1
      if framecounter <= 0:
         framecounter = framelimit
         (scoreA,scoreB) = score
         plusA = batA.getscore()
         if plusA != 0:
            scoreA += plusA
            batA_status.set_text( "SCORE %i . %i" % (scoreA,lives[0]))
         plusB = batB.getscore()
         if plusB != 0:
            scoreB += plusB
            batB_status.set_text( "SCORE %i . %i" % (scoreB,lives[1]))
         score = (scoreA,scoreB)
      changed_rects = []
      clock.tick(framelimit)
      for event in pygame.event.get():
         event = console.handle(event)
         if event.type == USEREVENT:
            #print 'YOU TYPED: "%s"' % event.command
            print >> console, "I was sure it was a bat."
            #ZZZ debug python interpreter goes here !
            print >> console, "BS = " + repr(bricksprites)
         else:
            if event.type is QUIT:
               return (0,(0,0),(0,0)) # quit
            elif event.type is KEYDOWN:
               if event.key is K_ESCAPE:
                  return (0,(0,0),(0,0))       # quit
               elif event.key == K_s:
                  silent = not silent
               elif event.key == K_p:
                  pause = not pause
               else:
                  keysdown[event.key] = 1
            elif event.type is KEYUP:
               if keysdown.has_key(event.key):
                  del keysdown[event.key]

      if not pause:
         if keysdown.has_key(K_q): batA.moveup()
         if keysdown.has_key(K_z): batA.movedown()
         if keysdown.has_key(K_a): batA.fireball()
         if keysdown.has_key(K_o): batB.moveup()
         if keysdown.has_key(K_m): batB.movedown()
         if keysdown.has_key(K_k): batB.fireball()
         if not bricksprites.__nonzero__:      #level complete if all bricksprites are gone
            return (-1,score,lives)    # -1 => still playing

         if doconsole:
            if console.consolechange:
               console.consolechange = 0  # reset bus ready
               if not console.visible:    # if just switched off... redraw background
                  screen.blit(background,(0,0))
                  changed_rects += [screen.get_rect()]

         #undraw the sprites
         ballsprites.clear(screen,background)
         batsprites.clear(screen,background)
         bricksprites.clear(screen,background)
         messagesprites.clear(screen,background)
         
         #move the sprites
         messagesprites.update()
         bricksprites.update()
         batsprites.update()
         ballsprites.update()
      
         #draw the sprites
         changed_rects += messagesprites.draw(screen)
         changed_rects += bricksprites.draw(screen) 
         changed_rects += batsprites.draw(screen)
         changed_rects += ballsprites.draw(screen)

         #draw the console (over sprites)
         if doconsole:
            if console.visible:
               changed_rects += [console.draw()]
               screen.blit(console_surface,(0,0))

         pygame.event.pump()
         pygame.display.update(changed_rects)
         
   # while 1: ends

def main():
   #ZZZ do pypong levels
   levels = {}    # YYY so I could name them ?
   # [ BRICKS ] [ BATS ] [zzz amazing stuff goes here ]
   #zzz e.g. players could take turns to have small bat (but get more points)
   levels[1] = [ [1,2,3,1,2,3,1,2,1], [1,1] ]
   levels[2] = [ [1,0,0,1,1,1,0,0,1], [1,1] ]
   levels[3] = [ [3,0,0,3,1,3,0,0,3], [1,1] ]
   level_num = 1    # ZZZ override with password/choice ?
   score = (0,0)
   lives = (3,3)
   playing = -1
   while playing:
      if levels.has_key(level_num):
         # GONE UP A LEVEL
         (playing,score,lives) = level(level_num,levels[level_num],score,lives)
         if playing:
            #ZZZ UP A LEVEL SOUND if not silent: uplevel_hurrah_sound.play()
            level_num += 1
      else:    # ZZZ things to do here
         playing = 0
   # end of game ZZZ highscores, attract screens &c. &c.
   print "FINISHED"    # ZZZ random hard levels
   print "YOU SCORED " + repr(score)      # ZZZ two (or more) scores in there
   return
   

#GAME STARTS HERE            

def rungamebox(scoresinfo):
   os.chdir('../mygamebox')
   #ZZZ store central information and/or pass or maintain flag settings (e.g -f fullscreen)
   #ZZZ write scoresinfo to a file (use a standard module for this)
   RUN = ['python','mygamebox.py','-s','scoresfile'];
   t = open('trace','w+')
   try:
      os.execvp('python',RUN)       # this doesn't return
   except:
      print >> t, "couldn't restart gamebox", sys.exc_info()[0]
      print >> t, "suppl ", sys.exc_info()[1]
   t.close()

def play_standalone():
   global screen
   global OPTIONS
   OPTIONS['fullscreen'] = 0
   OPTIONS['fromgamebox'] = 0
   try:
      opts, args = getopt.getopt(sys.argv[1:], "hfx", ["help", "output=","fromgamebox"])
   except getopt.GetoptError:
      usage()
      sys.exit(2)
   for o, a in opts:
      if o in ("-h", "--help"):
         usage()
         sys.exit()
      if o == '-f':
         OPTIONS['fullscreen'] = 1
      if o == '-x':
         OPTIONS['fromgamebox'] = 1
   pygame.init()
   if OPTIONS['fullscreen']:
      screen = pygame.display.set_mode((640,480),FULLSCREEN)
   else:
      screen = pygame.display.set_mode((640,480))
   if screen.get_bytesize() < 2:       # We need better than 8 bit color depth
      print "This program requires more than 256 colours."
      print "Please change your display to 16bit or 32bit colour."
      raise SystemExit
   print "CWD = [" + str(os.getcwd()) + "]"
   pygame.display.set_caption('excessive P Y P O N G')
   pygame.mouse.set_visible(0)
   main()
   if OPTIONS['fromgamebox']:
      print "returning to gamebox"
      rungamebox('dummyscoresinfo')


if __name__ == '__main__':
   play_standalone()

# end of file pypong.py
